// Pseudocode:
// int array_top = RAM[0] + RAM[1];
// int i = RAM[1];
// while(i < array_top) {
//     int j = RAM[1];
//     // Starting from the i'th element of the array, sweep through looking for adjacent pairs 
//     // of elements in the wrong order.
//     while(j < array_top) {
//         if (RAM[j-1] > RAM[j]) {
//             // When we find a pair in the wrong order, swap them round.
//             int temp = RAM[j-1];
//             RAM[j-1] = RAM[j];
//             RAM[j] = temp;
//         }
//         j++;
//     }
//     i++;
// }
// Halt.

// int array_top = RAM[0] + RAM[1];
@R0
D=M
@R1
D=M+D
@array_top
M=D
// int i = RAM[1];
@R1
D=M
@i
M=D

// while(i < array_top) {
(outer_loop)
@i
D=M
@array_top
D=D-M
@halt
D;JGE

//     int j = RAM[1];
@R1
D=M
@j
M=D

//     while(j < array_top) {
(inner_loop)
@j
D=M
@array_top
D=D-M
@end_inner_loop
D;JGE

//         if (RAM[j-1] > RAM[j]) {
@j
A=M-1
D=M
@j
A=M
D=D-M
@endif
D;JLE

//             int temp = RAM[j-1];
@j
A=M-1
D=M
@temp
M=D
//             RAM[j-1] = RAM[j];
@j
A=M
D=M
@j
A=M-1
M=D
//             RAM[j] = temp;
@temp
D=M
@j
A=M
M=D

//         }
(endif)

//         j++;
@j
M=M+1
//     }
@inner_loop
0;JMP
(end_inner_loop)

//     i++;
@i
M=M+1
// }
@outer_loop
0;JMP
(halt)

// Halt.
@halt
0;JMP