// Pseudocode:
// bool divisible_by_eight = false;
// if (RAM[0] & 8 > 0) {
//     divisible_by_eight = true;
// }
// bool divisible_by_eight = RAM[0] & 8
// bool divisible_by_sixteen = false;
// if (RAM[0] & 16 > 0) {
//     divisible_by_sixteen = true;
// }
// RAM[1] = divisible_by_eight && (!divisible_by_sixteen)
// Halt

// bool divisible_by_eight = false;
@divisible_by_eight
M=0
// if (RAM[0] & 8 > 0) {
@R0
D=M
@8
D=D&A
@endifeight
D;JLE
//     divisible_by_eight = true;
@divisible_by_eight
M=1
// }
(endifeight)

// if (RAM[0] & 16 > 0) {
@R0
D=M
@8
D=D&A
@endifsixteen
D;JLE
//     divisible_by_sixteen = true;
@divisible_by_sixteen
M=1
// }
(endifsixteen)

// RAM[1] = divisible_by_eight & (!divisible_by_sixteen)
// (This is the same as setting RAM[1] = 1 if RAM[0] is divisible by 8, but not by 16.)
@divisible_by_sixteen
D=!M
@divisible_by_eight
D=D&M
@R1
M=D

// Halt
(halt)
@halt
0;JMP