// Pseudocode:
// // Initialise our array to "all prime" except RAM[101].
// RAM[101] = 0;
// address = 102;
// sieve_top = 100 + RAM[0];
// while (address <= sieve_top) {
//     RAM[address] = 1;
//     address++;
// }
// // Run the sieve of Eratosthenes.
// i = 2;
// while (i <= RAM[0]) {
//     // If the current number i is composite, ignore it.
//     if (RAM[100+i] == 0) {
//         i++;
//         continue;
//     }
//     // Otherwise, do a sweep through the array marking off all numbers divisible by i as composite.
//     int j=2*i;
//     while (j <= RAM[0]) {
//         RAM[j+100] = 0;
//         j += i;
//     }
//     i++;
// }
// // Copy the resulting list of primes into memory.
// read_address = 102;
// write_address = 50
// while (read_address <= sieve_top) {
//     if (RAM[read_address] == 1) {
//         RAM[write_address] = read_address - 100;
//         write_address++;
//     }
//     read_address++;
// }
// Halt.

// RAM[101] = 0;
@101
M=0
// address = 102;
@102
D=A
@address
M=D
// sieve_top = 100 + RAM[0];
@R0
D=M
@100
D=A+D
@sieve_top
M=D

// while (address <= sieve_top) {
(initloop)
@address
D=M
@sieve_top
D=D-M
@endinit
D;JGT
//     RAM[address] = 1;
@address
A=M
M=1
//     address++;
@address
M=M+1
// }
@initloop
0;JMP
(endinit)

// i = 2;
@2
D=A
@i
M=D

// while (i <= RAM[0]) {
(sieveouter)
@i
D=M
@R0
D=D-M
@endsieve
D;JGT

//     if (RAM[100+i] == 0) {
@100
D=A
@i
D=D+M
A=D
D=M
@iprime
D;JNE
//         i++;
@i
M=M+1
//         continue;
@sieveouter
0;JMP
//     }
(iprime)

//     int j=2*i;
@i
D=M
@j
M=D
M=M+D

//     while (j <= RAM[0]) {
(sieveinner)
@j
D=M
@R0
D=D-M
@endsieveinner
D;JGT
//         RAM[j+100] = 0;
@100
D=A
@j
A=D+M
M=0
//         j += i;
@i
D=M
@j
M=M+D
//     }
@sieveinner
0;JMP
(endsieveinner)

//     i++;
@i
M=M+1
// }
@sieveouter
0;JMP
(endsieve)

// read_address = 102;
@102
D=A
@read_address
M=D
// write_address = 50
@50
D=A
@write_address
M=D

// while (read_address <= sieve_top) {
(copyprimes)
@read_address
D=M
@sieve_top
D=D-M
@halt
D;JGT
//     if (RAM[read_address] == 1) {
@read_address
A=M
D=M-1
@endcopyif
D;JNE
//         RAM[write_address] = read_address - 100;
@read_address
D=M
@100
D=D-A
@write_address
A=M
M=D
//         write_address++;
@write_address
M=M+1
//     }
(endcopyif)
//     read_address++;
@read_address
M=M+1
// }
@copyprimes
0;JMP
(halt)
// Halt.
@halt
0;JMP