// Pseudocode:
// // Set write_address to the null terminator of the first string.
// write_address = RAM[0]
// while(RAM[write_address] != 0) {
//     write_address++;
// }
// // Copy the second string into the first string character-by-character up to the null terminator.
// read_address = RAM[1]
// while(RAM[read_address] != 0) {
//     RAM[write_address] = RAM[read_address];
//     write_address++;
//     read_address++;
// } 
// // Add the null terminator in.
// RAM[write_address] = 0;
// Halt.

// write_address = RAM[0]
@R0
D=M
@write_address
M=D

// while(RAM[write_address] != 0) {
(first_loop)
@write_address
A=M
D=M
@first_loop_end
D;JEQ
//     write_address++;
@write_address
M=M+1
// }
@first_loop
0;JMP
(first_loop_end)

// read_address = RAM[1]
@R1
D=M
@read_address
M=D

// while(RAM[read_address] != 0) {
(second_loop)
@read_address
A=M
D=M
@second_loop_end
D;JEQ
//     RAM[write_address] = RAM[read_address];
@read_address
A=M
D=M
@write_address
A=M
M=D
//     write_address++;
@write_address
M=M+1
//     read_address++;
@read_address
M=M+1
// } 
@second_loop
0;JMP
(second_loop_end)

// RAM[write_address] = 0;
@write_address
A=M
M=0
// Halt.
(halt)
@halt
0;JMP